//Initiallising node modules
var express = require("express");
var bodyParser = require("body-parser");
var sql = require("mssql");
var app = express();

var Connection = require('tedious').Connection;
var Request = require('tedious').Request;

var config = 
{
	userName: 'UPDATE-ME', 
	password: 'UPDATE-ME', 
	server: 'UPDATE-ME', 
	options: 
	{
		database: 'UPDATE-ME' ,
		rowCollectionOnRequestCompletion: true
		, encrypt: true
	}
}
var connection = new Connection(config);

connection.on('connect', function(err) 
{
	if (err) 
	{
		console.log(err)
	}
	else
	{
		console.log('connection ok')
	}
}
);

// Setting Base directory
app.use(bodyParser.json());

//CORS Middleware
app.use(function (req, res, next) {
    //Enabling CORS 
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Methods", "GET,HEAD,OPTIONS,POST,PUT");
    res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, contentType,Content-Type, Accept, Authorization");
    next();
});

//Setting up server
var server = app.listen(process.env.PORT || 1516, function () {
	var port = server.address().port;
	console.log("App now running on port", port);
});



var  executeQuery = function(res, query){	
	console.log('executeQuery');

	var data = [];

	request = new Request(
		"SELECT top 5 DESCRICAO, id, id_usuario FROM Pluviometro "
		,
		function(err, rowCount, rows) 
		{
			console.log(rowCount + ' row(s) returned');
			if (err) {
				console.log("Error while querying database :- " + err);
				res.send(err);
			}
			else {


				jsonArray = []
				rows.forEach(function (columns) {
					console.log('-'+columns);
					var rowObject ={};
					columns.forEach(function(column) {
						console.log(column.metadata.colName + '-' + column.value);
						rowObject[column.metadata.colName] = column.value;
					});
					jsonArray.push(rowObject)
				});

				res.send( jsonArray)
			}
		}
		);


	connection.execSql(request);
}

app.get("/api/articles", function(req , res){
	var query = "select * from articles";
	executeQuery (res, query);
});

//POST API
app.post("/api/user ", function(req , res){
	var query = "INSERT INTO [user] (Name,Email,Password) VALUES (req.body.Name,req.body.Email,req.body.Password)";
	executeQuery (res, query);
});

//PUT API
app.put("/api/user/:id", function(req , res){
	var query = "UPDATE [user] SET Name= " + req.body.Name  +  " , Email=  " + req.body.Email + "  WHERE Id= " + req.params.id;
	executeQuery (res, query);
});

// DELETE API
app.delete("/api/user /:id", function(req , res){
	var query = "DELETE FROM [user] WHERE Id=" + req.params.id;
	executeQuery (res, query);
});
